use clap::{arg, Command, Parser};
use gpcommon::{Client, SOCKET_PATH};
use tokio::{io::AsyncReadExt, net::UnixStream, sync::mpsc};
use url::Url;

fn cli() -> Command {
    Command::new("gpclient")
        .about("GlobalProtect-openconnect CLI client")
        .subcommand_required(true)
        .arg_required_else_help(true)
        .subcommand(
            Command::new("connect")
                .about("Connect to GlobalProtect VPN")
                .arg(arg!(<SERVER> "The GlobalProtect server"))
                .arg_required_else_help(true),
        )
        .subcommand(Command::new("disconnect").about("Disconnect from GlobalProtect VPN"))
}

#[tokio::main]
async fn main() {
    // let mut stream = UnixStream::connect(SOCKET_PATH).await.unwrap();

    // let mut buf = [0u8; 34];
    // let _ = stream.read(&mut buf).await.unwrap();

    // // The first two bytes are the port number, the rest is the AES key
    // let http_port = u16::from_be_bytes([buf[0], buf[1]]);
    // let aes_key = &buf[2..];

    // println!("http_port: {http_port}");
    // println!("aes_key: {aes_key:?}");
    // let (output_tx, mut output_rx) = mpsc::channel::<String>(32);
    // let client = Client::default();

    // tokio::select! {
    //     _ = client.run() => {
    //         println!("Client finished");
    //     }
    // }

    let matches = cli().get_matches();
    match matches.subcommand() {
        Some(("connect", sub_m)) => {
            let server = sub_m.get_one::<String>("SERVER").expect("Missing server");
            let server = if server.starts_with("https://") || server.starts_with("http://") {
                server.to_string()
            } else {
                format!("https://{}", server)
            };

            let url = Url::parse(&server).expect("Invalid server URL");
            let host = url.host_str().expect("Invalid server URL");

            // let portal = Portal::new(host);
            // let prelogin = portal.prelogin().await;
        }
        Some(("disconnect", _)) => {
            println!("Disconnecting...");
        }
        _ => unreachable!(),
    }
}
